---
kind: StatefulSet
apiVersion: apps/v1
metadata:
  name: kafka
spec:
  selector:
    matchLabels:
      app: kafka
  serviceName: "kafka-svc"
  replicas: 1
  template:
    metadata:
      labels:
        app: kafka
    spec:
      containers:
        - name: kafka
          image: ubuntu/kafka:latest
          ports:
            - containerPort: 9092
              name: kafka
          volumeMounts:
            - name: kafka-data
              mountPath: /data/kafka
          args:
            - /etc/kafka/server.properties
            - --override
            - log.dirs=/data/kafka/logs
          env:
            - name: AUTO_CREATE_TOPICS_ENABLE
              value: "true"
            - name: ZOOKEEPER_HOST
              value: zookeeper-svc
            - name: KAFKA_BROKER_ID
              value: "1"
            - name: KAFKA_ADVERTISED_LISTENERS
              value: PLAINTEXT://kafka-svc:9092
            - name: KAFKA_LISTENER_SECURITY_PROTOCOL_MAP
              value: PLAINTEXT:PLAINTEXT,PLAINTEXT_HOST:PLAINTEXT
            - name: KAFKA_INTER_BROKER_LISTENER_NAME
              value: PLAINTEXT
            - name: KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR
              value: "1"
          resources:
            requests:
              memory: 1200M
              cpu: 400m
            limits:
              memory: 1200M
              cpu: 400m
  volumeClaimTemplates:
    - metadata:
        name: kafka-data
      spec:
        accessModes: [ "ReadWriteOnce" ]
        resources:
          requests:
            storage: 1Gi

---
apiVersion: v1
kind: Service
metadata:
  name: kafka-svc
  labels:
    app: kafka
spec:
#  clusterIP: None
  ports:
    - port: 9092
      name: kafka-port
  selector:
    app: kafka
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: zookeeper-config
data:
  zookeeper.properties: |
    dataDir=/data/zookeeper
    # the port at which the clients will connect
    clientPort=2181
    # disable the per-ip limit on the number of connections since this is a non-production config
    maxClientCnxns=0
    # Disable the adminserver by default to avoid port conflicts.
    # Set the port to something non-conflicting if choosing to enable this
    admin.enableServer=false
    # admin.serverPort=8080
---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: zookeeper
spec:
  selector:
    matchLabels:
      app: zookeeper
  serviceName: zookeeper-svc
  replicas: 1
  template:
    metadata:
      labels:
        app: zookeeper
    spec:
      volumes:
        - name: zookeeper-config
          configMap:
            name: zookeeper-config
      containers:
        - name: zookeeper
          image: ubuntu/zookeeper:latest
          ports:
            - containerPort: 2181
              name: zookeeper
          env:
            - name: ZOOKEEPER_CLIENT_PORT
              value: "2181"
            - name: ZOOKEEPER_TICK_TIME
              value: "2000"
            - name: ZOOKEEPER_DATADIR
              value: /data/zookeeper
          volumeMounts:
            - name: zookeeper-data
              mountPath: /data/zookeeper/
            - name: zookeeper-config
              mountPath: /etc/kafka/
          resources:
            requests:
              memory: 400M
              cpu: 350m
            limits:
              memory: 400M
              cpu: 350m
  volumeClaimTemplates:
    - metadata:
        name: zookeeper-data
      spec:
        accessModes: [ "ReadWriteOnce" ]
        resources:
          requests:
            storage: 1Gi
---
apiVersion: v1
kind: Service
metadata:
  name: zookeeper-svc
  labels:
    app: zookeeper
spec:
#  clusterIP: None
  ports:
    - port: 2181
      name: zookeeper-port
  selector:
    app: zookeeper